﻿package 
{
	import com.greensock.*;
	import flash.display.*;
	import flash.text.*;
	import flash.geom.*;
	import flash.events.MouseEvent;
	import flash.events.Event;
    import flash.media.Sound;
	import flash.net.URLRequest;
	
	/**
	 * @author Niels Erik Kaaber Rasmussen
	 */

	public class Main extends Sprite {
		public function Main():void {
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
	
		private function init(e:Event = null):void {
			removeEventListener(Event.ADDED_TO_STAGE, init);

			//to be deleted...//
			var tmptext:TextField = new TextField(); //debug txt
			addChild(tmptext); //debug txt
			//to be deleted...//

			//entry point

			var circleNames:Array = new Array(
				"Agriculture", //dir code 3
				"External relations", //dir code 11
				"Competition policy", //dir code 8				
				"General, financial and\nInstitutional matters", //dir code 1
				"Industrial policy\nand internal market", //dir code 13
				"Environment, consumers and\nhealth protection", //dir code 15
				"Customs Union and\nfree movement of goods", //dir code 2
				"Fisheries",  //dir code 4
				"Freedom of movement\nfor workers and social policy", //dir code 5
				"Transport policy", //dir code 7
				"Economic and monetary policy\nand free movement of capital", //dir code 10
				"Energy", //dir code 12
				"Regional policy and coordination\nof structural instruments", //dir code 14
				"Law relating\nto undertakings", //dir code 17
				"Common Foreign and\nSecurity Policy", //dir code 18
				"Area of freedom\nsecurity and justice", //dir code 19
				"Science, information,\neducation and culture", //dir code 16
				"Taxation", //dir code 9
				"Right of establishment\nand freedom to provide services", //dir code 6
				"People's Europe");  //dir code 20  //Navnet på hver cirkel
				
				var circleDescription:Array = new Array(
				"Agriculture\n\n\nDirectives: 616\nRegulations: 4448\nDecisions: 3100", //dir code 3
				"External relations\n\n\nDirectives: 6\nRegulations: 1183\nDecisions: 4296", //dir code 11
				"Competition policy\n\n\nDirectives: 4\nRegulations: 65\nDecisions: 5641", //dir code 8
				"General, financial and Institutional mattersn\n\nDirectives: 20\nRegulations: 372\nDecisions: 927", //dir code 1
				"Industrial policy and internal marketn\n\nDirectives: 846\nRegulations: 350\nDecisions: 768", //dir code 13
				"Environment, consumers and health protectionn\n\nDirectives: 277\nRegulations: 612\nDecisions: 597", //dir code 15
				"Customs Union and free movement of goodsn\n\nDirectives: 17\nRegulations: 974\nDecisions: 662", //dir code 2
				"Fisheriesn\n\nDirectives: 2\nRegulations: 864\nDecisions: 203",  //dir code 4
				"Freedom of movement for workers and social policyn\n\nDirectives: 88\nRegulations: 138\nDecisions: 184", //dir code 5
				"Transport policyn\n\nDirectives: 174\nRegulations: 277\nDecisions: 236", //dir code 7
				"Economic and monetary policy and free movement of capitaln\n\nDirectives: 13\nRegulations: 154\nDecisions: 196", //dir code 10
				"Energyn\n\nDirectives: 30\nRegulations: 46\nDecisions: 196", //dir code 12
				"Regional policy and coordination of structural instrumentsn\n\nDirectives: 5\nRegulations: 144\nDecisions: 299", //dir code 14
				"Law relating to undertakings", //dir code 17
				"Common Foreign and Security Policy", //dir code 18
				"Area of freedom security and justice", //dir code 19
				"Science, information,education and culture", //dir code 16
				"Taxation", //dir code 9
				"Right of establishment and freedom to provide services", //dir code 6
				"People's Europe");  //dir code 20  //Navnet på hver cirkel
				
			var circleCenterX:Array = new Array( //Centrum (x-koordinat) for hvert stadie/år af hver cirkel
				new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array()
			);
			var circleCenterY:Array = new Array( //Centrum (y-koordinat) for hvert stadie/år af hver cirkel
				new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array(), new Array()
			);

			var circleRadius:Array = new Array(  //Radius for hvert stadie/år af hver cirkel
				new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 2, 9, 10, 11, 12, 13, 17, 21, 26, 31, 34, 38, 42, 45, 50, 53, 57, 62, 71, 74, 81, 84, 88, 91, 93, 97, 100, 105, 106, 108, 109, 112, 114, 113, 114, 110, 112, 113, 114, 112, 112, 112, 114, 117, 117, 121, 124, 126, 127, 127),//dc 3
				new Array(0,0,0,2,2,2,2,3,4,6,6,8,9,10,11,11,11,13,14,15,17,19,21,27,32,34,35,36,37,45,43,52,57,59,61,60,61,59,62,64,67,67,68,67,69,71,73,75,79,83,87,91,95,98,103,106,109,112,115,117,116),//dc 11
				new Array(0,0,0,1,3,2,4,5,6,6,6,4,6,7,7,8,9,9,11,13,13,14,15,16,17,18,19,20,22,23,23,25,26,27,28,29,30,31,33,34,36,38,40,42,44,47,50,54,58,64,70,75,79,83,86,89,94,98,102,104,105),//dc 8
				new Array(0,0,0,3,4,5,5,6,7,7,8,9,10,10,10,11,11,12,12,12,13,13,15,16,16,17,17,18,19,20,21,23,24,25,25,25,25,25,26,27,28,28,29,30,32,34,35,38,41,41,43,44,45,44,48,50,52,52,54,58,57),//dc 1
				new Array(0, 0, 0, 3, 5, 4, 5, 5, 5, 5, 5, 6, 6, 6, 8, 9, 9, 9, 10, 12, 13, 14, 15, 16, 19, 20, 22, 25, 27, 30, 29, 31, 33, 34, 34, 34, 35, 35, 37, 38, 40, 40, 42, 43, 45, 45, 46, 50, 52, 53, 53, 54, 56, 57, 58, 59, 60, 62, 64, 66, 65),//dc 13
				new Array(0,0,0,0,0,0,0,0,0,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,6,9,10,10,12,14,15,16,17,18,19,20,22,23,25,27,29,29,31,34,35,35,36,39,40,42,44,46,48,50,51,53,54,56,58,61,60),//dc 15
				new Array(0,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,8,9,12,14,16,18,20,25,28,31,34,36,38,40,46,45,50,54,56,55,55,57,56,57,58,59,59,61,57,52,52,53,53,54,54,55,56,56,57,57,57,58,59,60,59),//dc 2
				new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,3,3,3,5,6,6,7,8,9,10,11,13,14,16,18,21,23,24,27,29,29,31,32,34,34,34,34,35,36,35,35,36,35,34,34,35,37,39,41,44,47,48,48),//dc 4
				new Array(0,0,0,0,0,0,0,1,1,3,5,5,6,7,9,9,9,10,10,10,11,11,14,12,13,14,16,16,17,18,18,19,20,20,20,21,21,22,23,24,25,25,25,25,26,26,27,28,28,29,29,29,30,31,32,32,32,32,33,34,34),//dc 5
				new Array(0, 0, 0, 0, 0, 1, 2, 2, 3, 4, 4, 5, 6, 6, 6, 7, 8, 8, 9, 10, 11, 11, 12, 13, 14, 15, 16, 18, 19, 20, 21, 21, 22, 23, 24, 24, 25, 25, 25, 26, 27, 27, 29, 29, 29, 30, 31, 31, 32, 32, 33, 34, 34, 35, 36, 37, 38, 40, 41, 43, 43),//dc 7
				new Array(0,0,0,0,0,0,0,0,1,2,2,2,3,3,4,4,4,4,4,4,4,6,6,7,8,9,9,10,11,12,12,12,13,14,14,13,12,12,12,12,12,12,11,12,12,12,13,14,17,20,21,22,24,26,28,29,31,32,33,35,35),//dc 10
				new Array(0, 0, 0, 2, 2, 2, 4, 5, 6, 8, 7, 7, 7, 8, 8, 9, 9, 9, 10, 10, 10, 10, 11, 12, 13, 14, 15, 16, 17, 19, 20, 20, 20, 21, 21, 22, 22, 21, 22, 23, 23, 24, 24, 24, 24, 24, 24, 24, 25, 26, 26, 26, 27, 28, 28, 28, 28, 28, 29, 30, 30),//dc 12
				new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,2,2,2,3,3,3,3,4,5,5,5,6,7,8,10,11,13,13,12,13,15,21,22,23,23,27,26,25,25,28,29,30,28,31,31,31,32,32,33,29,29,30,30),//dc 14
				new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,3,4,4,5,5,5,5,5,5,5,6,6,7,7,7,7,8,9,10,10,10,11,12,12,12,13,13,13,14,14,16,17,18,18,19,20,21,21),//dc 17
				new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,7,10,12,13,16,19,20,21,24,27,30,34,36,38,41,43,43),//dc 18
				new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 3, 4, 4, 4, 4, 5, 5, 6, 7, 9, 13, 16, 18, 20, 23, 25, 27, 28, 29, 31, 32, 33, 35, 37, 39, 39),//dc 19
				new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,3,3,3,4,4,4,6,6,7,7,9,10,11,11,13,13,12,14,15,15,15,16,19,21,23,22,24,23,24,24,25,25,26,27,27,28,29,30,31,30,31,31,31),//dc 16
				new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 2, 2, 4, 4, 4, 5, 5, 6, 6, 6, 7, 8, 8, 8, 9, 10, 10, 11, 11, 11, 11, 12, 13, 13, 13, 14, 16, 16, 17, 16, 18, 18, 19, 19, 20, 21, 21, 23, 23, 24, 23, 23, 23, 23),//dc 9
				new Array(0,0,0,0,0,0,0,0,0,0,0,2,2,4,6,6,6,7,8,9,9,9,10,10,11,12,12,14,15,15,15,16,16,16,16,17,18,18,18,19,19,20,21,22,22,22,22,22,23,24,22,22,22,23,23,24,24,25,25,25,25),//dc 6
				new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,2,2,3,3,3,3,3,3,4,4,4,4,4,5,5,5,5,6,6,6,6,6,6,7,7,7,7,7,7) //dc 20
			);

			const fixedPositions:Boolean = true; //fixed position of circles or moving circles
			const timeunit:Number = 0.5; //in seconds
			const maxYear:int = 60; //60 = 2010
			//const numberOfCircles = 20;

			var thisyear:int = 0; //current year from 1950

			/*	var b1:Bubble = new Bubble(12,'test bubble');
			addChild(b1);
			TweenLite.to(b1, 2, { scaleX:2, scaleY:4 } ); //resize circles
			b1.x = 100;*/
			
			var fontLoader:Loader = new Loader();
			var fontLoaderInfo:LoaderInfo = fontLoader.contentLoaderInfo;
			fontLoaderInfo.addEventListener(Event.COMPLETE, onFontLoaded);
			fontLoader.load(new URLRequest("arial.swf"));
			
			var circleSound:Sound = new Sound(); 
			circleSound.load(new URLRequest("circlesound.mp3")); 
			//circleSound.addEventListener(Event.COMPLETE, soundLoaded); 

			var yearSound:Sound = new Sound(); 
			yearSound.load(new URLRequest("yearsound.mp3")); 
			

			
			
			//place circles
			for (var j:int = 0; j < circleRadius.length; j++) {
				var tmpX:int = Math.floor(Math.random() * (1 + 780 - circleRadius[j][maxYear] - circleRadius[j][maxYear])) + circleRadius[j][maxYear];
				var tmpY:int = Math.floor(Math.random() * (1 + 515 - circleRadius[j][maxYear] - circleRadius[j][maxYear]-5)) + circleRadius[j][maxYear]+5;
				circleCenterX[j][0] = tmpX;
				circleCenterY[j][0] = tmpY;
	
				//check for overlap
				var it:int = 0;
				while (overlap(j)) {
					if (it++ > 10000) break;
					tmpX = Math.floor(Math.random() * (1 + 780 - circleRadius[j][maxYear] - circleRadius[j][maxYear])) + circleRadius[j][maxYear];
					tmpY = Math.floor(Math.random() * (1 + 515 - circleRadius[j][maxYear] - circleRadius[j][maxYear]-5)) + circleRadius[j][maxYear]+5;
					circleCenterX[j][0] = tmpX;
					circleCenterY[j][0] = tmpY;
				}
			}
			
			  
			var myFormat:TextFormat = new TextFormat("Arial", 10, 0);
			myFormat.align = TextFormatAlign.CENTER;
			myFormat.color = "0x333333";
			myFormat.bold = false;

			var yearFormat:TextFormat = new TextFormat("Arial", 10, 0);
			yearFormat.align = TextFormatAlign.LEFT;
			yearFormat.color = "0x333333";
			yearFormat.bold = false;

			var yearFormatb:TextFormat = new TextFormat("Arial", 10, 0);
			yearFormatb.align = TextFormatAlign.LEFT;
			yearFormatb.color = "0x000000";
			yearFormatb.bold = true;

			var infoFieldFormat:TextFormat = new TextFormat("Arial", 12, 0);
			infoFieldFormat.align = TextFormatAlign.LEFT;
			infoFieldFormat.color = "0x000000";

			var myFormatHeader:TextFormat = new TextFormat("Arial", 13, 0);
			myFormatHeader.align = TextFormatAlign.CENTER;
			myFormatHeader.color = "0x333333";
			myFormatHeader.bold = true;			

			var myFormatb:TextFormat = new TextFormat("Arial", 10, 0);
			myFormatb.align = TextFormatAlign.CENTER;
			myFormatb.color = "0x000000";
			myFormatb.bold = true;

			var circRad:int = 1; //initial circle radius
			var matr:Matrix = new Matrix();
			matr.createGradientBox(2 * circRad, 2 * circRad, 0, -circRad + 0.3, -circRad - 0.3);
			
			var shadowMatr:Matrix = new Matrix();
			circRad = 1.2;
			shadowMatr.createGradientBox(2 * circRad, 2 * circRad, 0, -circRad, -circRad);

			var circles:Array = [];
			var circleShadow:Array = [];
			var circlesText:Array = [];
			for (var ci:int = 0; ci < circleNames.length; ci++ ) {
				circleShadow[ci] = new Sprite();
				circleShadow[ci].graphics.beginFill(0xAAAAAA);
				circleShadow[ci].graphics.drawCircle(0, 0, 1);
				circleShadow[ci].graphics.endFill();
				circleShadow[ci].alpha = 1;
				circleShadow[ci].x = circleCenterX[ci][thisyear]-10;
				circleShadow[ci].y = circleCenterY[ci][thisyear] + 10;
				var sg:Graphics = circleShadow[ci].graphics;
				sg.beginGradientFill(GradientType.RADIAL, [0x999999,0xAAAAAA,0xFFFFFF], [1,1,1], [0,200,255], shadowMatr, SpreadMethod.PAD);
				sg.drawCircle( 0, 0, 1);
				circleShadow[ci].rotation = -45;
				addChild(circleShadow[ci]);
				setChildIndex(circleShadow[ci], 0);
				
				circles[ci] = new Sprite();
				circles[ci].alpha = 0.7;
				circles[ci].x = circleCenterX[ci][thisyear];
				circles[ci].y = circleCenterY[ci][thisyear];
				
				circles[ci].addEventListener(MouseEvent.ROLL_OVER, over);
				circles[ci].addEventListener(MouseEvent.ROLL_OUT, out);
				
				var g:Graphics = circles[ci].graphics;
				var clr:int = Math.random() * 0xFFFFFF;
				g.beginGradientFill(GradientType.RADIAL, [0xAAAAAA,clr], [1,1], [0,255], matr, SpreadMethod.PAD);
				g.drawCircle( 0, 0, 1);
				
				addChild(circles[ci]);

				circlesText[ci] = new TextField();
				circlesText[ci].embedFonts = true;
				circlesText[ci].antiAliasType = AntiAliasType.ADVANCED;
				circlesText[ci].defaultTextFormat = myFormat;
				circlesText[ci].text = circleNames[ci]; // +String(ci); //set name of circle
				circlesText[ci].width = 200;
				circlesText[ci].x = Math.max(circleCenterX[ci][thisyear] - 100, -100);
				circlesText[ci].y = circleCenterY[ci][thisyear] - 7;
				circlesText[ci].mouseEnabled = false;
			}

 /*
			var dropShadow:DropShadowFilter = new DropShadowFilter();
			dropShadow.distance = 10; 
			dropShadow.angle = 115;
			circles[0].filters = [dropShadow];
 */
			
			var infoField:Sprite = new Sprite();
			infoField.graphics.lineStyle(1,0xAAAAAA);
			infoField.graphics.beginFill(0xEEEEEE);
			infoField.graphics.drawRect(800,-2,200,800);
			infoField.graphics.endFill();
			addChild(infoField);

			var infoFieldText:TextField = new TextField();
			//infoFieldText.embedFonts = true;
			//infoFieldText.border = true;
			infoFieldText.antiAliasType = AntiAliasType.ADVANCED;
			infoFieldText.wordWrap = true;
			infoFieldText.defaultTextFormat = infoFieldFormat;
			infoFieldText.text = "Each bubble represents a specific area of European Union activity. The area of the bubble reflects the number of EU legislative acts within the policy area.\n\nUse the timeline to navigate in time. Place the cursor on a bubble to see additional information."; // +String(ci); //set name of circle
			infoFieldText.width = 180;
			infoFieldText.height = 400;
			infoFieldText.x = 810;
			infoFieldText.y = 75;
			infoFieldText.mouseEnabled = false;
			addChild(infoFieldText);

			var infoFieldHeader:TextField = new TextField();
			//infoFieldHeader.embedFonts = true;
			infoFieldHeader.antiAliasType = AntiAliasType.ADVANCED;
			infoFieldHeader.wordWrap = true;
			infoFieldHeader.defaultTextFormat = myFormatHeader;
			infoFieldHeader.text = "EU legislation"; // +String(ci); //set name of circle
			infoFieldHeader.width = 200;
			infoFieldHeader.height = 70;
			infoFieldHeader.x = 800;
			infoFieldHeader.y = 20;
			infoFieldHeader.mouseEnabled = false;
			addChild(infoFieldHeader);
			
			var timelinebar:Sprite = new Sprite();
			var timeline:Sprite = new Sprite();
			var years:Array = [];
			var yearButtons:Array = [];

			startAnimation();
			
		function addYears():void { //add years and timeline
//			tmptext.text = 'addyears';
			timeline.graphics.lineStyle(1,0x333333);
			timeline.graphics.beginFill(0xAAAAAA);
			timeline.graphics.drawRect(15,520,770,4);
			timeline.graphics.endFill();
			addChild(timeline);
			
			//timelinebar.graphics.lineStyle(1,0xFF0000);
			timelinebar.graphics.beginFill(0xFF0000);
			timelinebar.graphics.drawRect(0, 521, 1, 4);
			timelinebar.x = 15;
			timelinebar.graphics.endFill();
			timelinebar.alpha = 0.5;
			addChild(timelinebar);
			
			for (var i:int = 0; i <= maxYear; i++) {
				years[i] = new TextField();
				//years[i].autoSize = TextFieldAutoSize.LEFT;
				years[i].defaultTextFormat = yearFormat;
				years[i].x = 12.8 * i + 19;
				years[i].y = 523;
				years[i].background = false;
				years[i].embedFonts = true;
				years[i].rotation = 65;
				years[i].text = String(1950 + i);
				years[i]..mouseEnabled = false;
				addChild(years[i]);
				
				yearButtons[i] = new Sprite();
//				yearButtons[i].graphics.lineStyle(1,0xAAAAAA);
				yearButtons[i].graphics.beginFill(0xAAAAAA);
				yearButtons[i].alpha = 0;
				yearButtons[i].graphics.drawRect(0,0,12.8,50);
				yearButtons[i].graphics.endFill();
				yearButtons[i].x = 12.8 * i + 10;
				yearButtons[i].y = 514;
				yearButtons[i].buttonMode = true;
				yearButtons[i].addEventListener(MouseEvent.CLICK, moveTimeline);
				yearButtons[i].addEventListener(MouseEvent.MOUSE_OVER, overYear);
				yearButtons[i].addEventListener(MouseEvent.MOUSE_OUT, outYear);
				addChild(yearButtons[i]);
			}
		} //end addYears
			
			function startAnimation():void {
				changeYear(0);
			}

			function moveTimeline(event:MouseEvent):void {
				yearSound.play(200);
				thisyear = yearButtons.indexOf(event.target);
					
				for (var cs:int = 0; cs < circleNames.length; cs++ ) {
					if (contains(circlesText[cs]) && (circleRadius[cs][thisyear] < 20 && thisyear <= 50)) {
						removeChild(circlesText[cs]);
					}
					else if (!contains(circlesText[cs]) && (circleRadius[cs][thisyear] > 20 || thisyear > 50)) {
						addChild(circlesText[cs]);
					}
				}
				changeYear(thisyear);
			} //end moveTimeline

			function changeYear(newyear:int):void {
				if (newyear > maxYear) return;
				thisyear = newyear;

				for (var ci:int = 0; ci < circleNames.length; ci++ ) {
					if (circleRadius[ci][thisyear] > 20 || thisyear > 50) {
						addChild(circlesText[ci]);
					}
					if (fixedPositions) {
						TweenLite.to(circles[ci], timeunit, { scaleX:circleRadius[ci][thisyear], scaleY:circleRadius[ci][thisyear] } ); //resize circles
						TweenLite.to(circleShadow[ci], timeunit, { scaleX:circleRadius[ci][thisyear], scaleY:circleRadius[ci][thisyear] } ); //resize circles
					}
					else {
						TweenLite.to(circlesText[ci], timeunit, { x:circleCenterX[ci][thisyear]-100, y:circleCenterY[ci][thisyear]-7 } ); //move text with circle
						TweenLite.to(circles[ci], timeunit, { x:circleCenterX[ci][thisyear], y:circleCenterY[ci][thisyear], scaleX:circleRadius[ci][thisyear], scaleY:circleRadius[ci][thisyear] } ); //resize circles
					}
				}
				TweenLite.to(timelinebar, timeunit, { scaleX:12.8 * thisyear + 2, onComplete:nextyear } ); //move timeline
			} //end changeYear

			function nextyear():void {
				changeYear(thisyear + 1);
			} //end nextYear

			function overlap(circleNr:int):Boolean {
				if (circleNr < 1) return false;
				for (var jij:int = circleNr-1; jij >= 0; jij--) {
					var a:int = circleCenterX[circleNr][0]-circleCenterX[jij][0];
					var b:int = circleCenterY[circleNr][0]-circleCenterY[jij][0];
					var r:int = circleRadius[circleNr][maxYear] + circleRadius[jij][maxYear];
					if (a * a + b * b < r * r) return true;
				}
				return false;
			} //end overlap

			function onFontLoaded (e:Event):void {
				var info:LoaderInfo = e.currentTarget as LoaderInfo;
				var loader:Loader = info.content as Loader;
				var embeddedFonts:Array = Font.enumerateFonts(false);
				for(var i:Number = 0; i < embeddedFonts.length; i++){
					var item:Font = embeddedFonts[i];
				}
				addYears(); //fonts are loaded now add text
			}
			
			function overYear (event:MouseEvent):void { //hover
				event.target.alpha = 0;	
				years[yearButtons.indexOf(event.target)].defaultTextFormat = yearFormatb;
				years[yearButtons.indexOf(event.target)].text = 1950+yearButtons.indexOf(event.target);
			} //end overYear
			
			function outYear (event:MouseEvent):void { //hover
				years[yearButtons.indexOf(event.target)].defaultTextFormat = yearFormat;
				years[yearButtons.indexOf(event.target)].text = 1950+yearButtons.indexOf(event.target);
			} //end outYear

			function over (event:MouseEvent):void { //hover
				event.target.alpha = 1;
				infoFieldHeader.text = circleNames[circles.indexOf(event.target)];
				infoFieldText.text = circleDescription[circles.indexOf(event.target)];
				circleSound.play(100);
				circlesText[circles.indexOf(event.target)].defaultTextFormat = myFormatb;
				circlesText[circles.indexOf(event.target)].text = circleNames[circles.indexOf(event.target)];
			} //end over
			
			function out (event:MouseEvent):void {
				event.target.alpha = 0.7;
				circlesText[circles.indexOf(event.target)].defaultTextFormat = myFormat;
				circlesText[circles.indexOf(event.target)].text = circleNames[circles.indexOf(event.target)];
			} //end out
			
		} //end init
	} //end main
} //end package