package 
{
	import flash.ui.Mouse;
	import flash.display.MovieClip;
	import flash.display.Sprite;;
	import flash.text.*;
	import flash.events.*;
	import com.greensock.*;
    import flash.media.Sound;
	import flash.net.URLRequest;
	import flash.geom.*;
	import com.greensock.easing.*;
	import flash.display.*; 

	/**
	 * ...
	 * @author Niels Erik Kaaber Rasmussen
	 */
	public class Scenary extends MovieClip {
		public var acts:Array, directives:Array, regulations:Array, decisions:Array, infoFieldActText:TextField, years:Array, yearButtons:Array, yearFormat:TextFormat, yearFormatb:TextFormat, yearSound:Sound, clickSound:Sound, timelinebar:Sprite, timeunit:Number, infoFieldText:TextField, infoFieldHeader:TextField,  rulerMarkTopText:TextField, rulerMarkMiddleText:TextField, rulerMark2Text:TextField, rulerMarkQuarterText:TextField, sceneTitleText:TextField;
		//public var myLine:Shape, myLineInner:Shape, replayText:TextField, buttonReplay:Sprite;
		public static const maxYear:int = 61; //60 = 2010

		public function Scenary(tunit:Number):void {
			
		var img1:Loader = new Loader();
		var replayImg:URLRequest = new URLRequest("replay.gif");
		img1.load(replayImg);
		addChild(img1);
		img1.x = 36;
		img1.y = 496;
		img1.alpha = 1;
		var img2:Loader = new Loader();
		var replayOverImg:URLRequest = new URLRequest("replayover.gif");
		img2.load(replayOverImg);
		addChild (img2);
		img2.x = 36;
		img2.y = 496;
		img2.alpha = 0;
		var img3:Loader = new Loader();
		var replayClickImg:URLRequest = new URLRequest("replaydown.gif");
		img3.load(replayClickImg);
		addChild(img3);
		img3.x = 36;
		img3.y = 496;
		img3.alpha = 0;

		var buttonReplay:Sprite = new Sprite();
		buttonReplay.graphics.beginFill(0xFFAAAA);
		buttonReplay.alpha = 0;
		buttonReplay.graphics.drawRect(34,499,15,12);
		buttonReplay.graphics.endFill();
		buttonReplay.buttonMode = true;
		addChild(buttonReplay);

		buttonReplay.addEventListener(MouseEvent.MOUSE_OVER, replayOver);
		buttonReplay.addEventListener(MouseEvent.MOUSE_OUT, replayOut);
		buttonReplay.addEventListener(MouseEvent.MOUSE_DOWN, replayDown);
		buttonReplay.addEventListener(MouseEvent.MOUSE_UP, replayUp);

			function replayUp (event:MouseEvent):void {
				MovieClip(parent).runAnimation = true;
				yearSound.play(200);
				MovieClip(parent).changeYear(0);
				replayOver(event);
			}
			function replayOver (event:MouseEvent):void {
				img1.alpha = 0;
				img2.alpha = 1;
				img3.alpha = 0;
				Mouse.cursor="button";
			}
			function replayOut (event:MouseEvent):void {
				img1.alpha = 1;
				img2.alpha = 0;
				img3.alpha = 0;
				Mouse.cursor="auto";
			}
			function replayDown (event:MouseEvent):void {
				img1.alpha = 0;
				img2.alpha = 0;
				img3.alpha = 1;
			}

			timeunit = tunit;

			yearSound = new Sound();
			yearSound.load(new URLRequest("yearsound.mp3"));

			clickSound = new Sound();
			clickSound.load(new URLRequest("clicksound.mp3"));
			
			addInfoBox();
			drawRuler();
			addYears();
			drawButtons();
			this.mouseEnabled = false;

			var sceneTitleFormat:TextFormat = new TextFormat("Arial", 12, 0);
			sceneTitleFormat.align = TextFormatAlign.CENTER;
			sceneTitleFormat.color = 0x333333;
			sceneTitleFormat.bold = true;

			sceneTitleText = new TextField();
			sceneTitleText.defaultTextFormat = sceneTitleFormat;
			sceneTitleText.x = 805;
			sceneTitleText.width = 190;
			sceneTitleText.y = 5;
			sceneTitleText.background = false;
			//sceneTitleText.text = sceneTitle;
			sceneTitleText.mouseEnabled = false;
			addChild(sceneTitleText);
			resetSceneTitle();
			
		function drawButtons():void {
			const buttonsLeft:int = 8;
			const buttonsTop:int = 499;
			const buttonsPlayLenght:int = 12;
			const buttonColor:int = 0xAAAAAA;

/*			var replaySize:int = 30;
			myLine = new Shape();  
myLine.graphics.lineStyle(8, 0x333333, 1, true);
myLine.graphics.curveTo(0, replaySize/2, replaySize/-2, replaySize/2);
myLine.graphics.curveTo( -replaySize, replaySize/2, -replaySize, 0);
myLine.graphics.curveTo( -replaySize, -replaySize/2, -replaySize/2, -replaySize/2);
myLine.graphics.lineTo( -replaySize*0.7, -replaySize*0.6);
myLine.graphics.moveTo( -replaySize/2, -replaySize/2);
myLine.graphics.lineTo( -replaySize*0.7, -replaySize*0.35);
myLine.x = 910;
myLine.y = 455;
			myLineInner = new Shape();  
myLineInner.graphics.lineStyle(6, buttonColor);
myLineInner.graphics.curveTo(0, replaySize/2, replaySize/-2, replaySize/2);
myLineInner.graphics.curveTo( -replaySize, replaySize/2, -replaySize, 0);
myLineInner.graphics.curveTo( -replaySize, -replaySize/2, -replaySize/2, -replaySize/2);
myLineInner.graphics.lineTo( -replaySize*0.7, -replaySize*0.6);
myLineInner.graphics.moveTo( -replaySize/2, -replaySize/2);
myLineInner.graphics.lineTo( -replaySize*0.7, -replaySize*0.35);
myLineInner.x = 910;
myLineInner.y = 455;

			var infoFieldFormat:TextFormat = new TextFormat("Arial", 14, 0);
			infoFieldFormat.align = TextFormatAlign.LEFT;
			infoFieldFormat.color = "0x000000";

			replayText = new TextField();
			replayText.defaultTextFormat = infoFieldFormat;
			replayText.x = 875;
			replayText.y = 480;
			replayText.text = 'Replay';

			buttonReplay = new Sprite();
			buttonReplay.graphics.beginFill(0xFFAAAA);
			buttonReplay.alpha = 0;
			buttonReplay.graphics.drawRect(845,425,100,80);
			buttonReplay.graphics.endFill();
			buttonReplay.buttonMode = true;
			buttonReplay.addEventListener(MouseEvent.MOUSE_UP, upReplay);
			buttonReplay.addEventListener(MouseEvent.MOUSE_DOWN, downReplay);
			buttonReplay.addEventListener(MouseEvent.MOUSE_OVER, overReplay);
			buttonReplay.addEventListener(MouseEvent.MOUSE_OUT, outReplay);


			var outColor:ColorTransform = new ColorTransform();
			outColor.color = buttonColor; 
			var overColor:ColorTransform = new ColorTransform();
			overColor.color = 0xe05555; 
			var downColor:ColorTransform = new ColorTransform();
			downColor.color = 0xff0000; 
			
			function outReplay (event:MouseEvent):void {
				myLineInner.transform.colorTransform = outColor;
			}
			
			function overReplay (event:MouseEvent):void {
				myLineInner.transform.colorTransform = overColor;				
			}

			function downReplay (event:MouseEvent):void {
				myLineInner.transform.colorTransform = downColor;
			}

			function upReplay (event:MouseEvent):void {
				MovieClip(parent).runAnimation = true;
				yearSound.play(200);
				MovieClip(parent).changeYear(0);
				overReplay(event);
			}
*/
	
			
			
			var buttonPlay:Sprite = new Sprite;
			buttonPlay.graphics.lineStyle(1, 0x333333);
			buttonPlay.graphics.beginFill(buttonColor);
			buttonPlay.graphics.moveTo(buttonsLeft, buttonsTop);
			buttonPlay.graphics.lineTo(buttonsLeft+buttonsPlayLenght, buttonsTop+buttonsPlayLenght/2);
			buttonPlay.graphics.lineTo(buttonsLeft, buttonsTop+buttonsPlayLenght);
			buttonPlay.graphics.lineTo(buttonsLeft, buttonsTop);
			buttonPlay.graphics.endFill();
			addChild(buttonPlay);
			
			var buttonPlayC:Sprite = new Sprite();
			buttonPlayC.graphics.beginFill(0xAAAAAA);
			buttonPlayC.alpha = 0;
			buttonPlayC.graphics.drawRect(buttonsLeft-1,buttonsTop-1,12,buttonsPlayLenght+3);
			buttonPlayC.graphics.endFill();
			buttonPlayC.buttonMode = true;
			buttonPlayC.addEventListener(MouseEvent.MOUSE_UP, upPlay);
			buttonPlayC.addEventListener(MouseEvent.MOUSE_OVER, overPlay);
			buttonPlayC.addEventListener(MouseEvent.MOUSE_OUT, outPlay);
			buttonPlayC.addEventListener(MouseEvent.MOUSE_DOWN, downPlay);
			addChild(buttonPlayC);
		
			function overPlay (event:MouseEvent):void {
				buttonPlay.graphics.beginFill(0xe05555);
				buttonPlay.graphics.moveTo(buttonsLeft, buttonsTop);
				buttonPlay.graphics.lineTo(buttonsLeft+buttonsPlayLenght, buttonsTop+buttonsPlayLenght/2);
				buttonPlay.graphics.lineTo(buttonsLeft, buttonsTop+buttonsPlayLenght);
				buttonPlay.graphics.lineTo(buttonsLeft, buttonsTop);
				buttonPlay.graphics.endFill();
			}

			function upPlay (event:MouseEvent):void {
				overPlay(event);
				if (!MovieClip(parent).runAnimation) {
					MovieClip(parent).runAnimation = true;
					MovieClip(parent).nextYear();
				}

			}

			function downPlay (event:MouseEvent):void {
				buttonPlay.graphics.beginFill(0xff0000);
				buttonPlay.graphics.moveTo(buttonsLeft, buttonsTop);
				buttonPlay.graphics.lineTo(buttonsLeft+buttonsPlayLenght, buttonsTop+buttonsPlayLenght/2);
				buttonPlay.graphics.lineTo(buttonsLeft, buttonsTop+buttonsPlayLenght);
				buttonPlay.graphics.lineTo(buttonsLeft, buttonsTop);
				buttonPlay.graphics.endFill();
				clickSound.play(0);
			}
			
			function outPlay (event:MouseEvent):void {
				buttonPlay.graphics.beginFill(buttonColor);
				buttonPlay.graphics.moveTo(buttonsLeft, buttonsTop);
				buttonPlay.graphics.lineTo(buttonsLeft+buttonsPlayLenght, buttonsTop+buttonsPlayLenght/2);
				buttonPlay.graphics.lineTo(buttonsLeft, buttonsTop+buttonsPlayLenght);
				buttonPlay.graphics.lineTo(buttonsLeft, buttonsTop);
				buttonPlay.graphics.endFill();
			}
			
			
			var buttonPause1:Sprite = new Sprite();
			buttonPause1.graphics.lineStyle(1,0x333333);
			buttonPause1.graphics.beginFill(buttonColor);
			buttonPause1.graphics.drawRect(buttonsLeft+buttonsPlayLenght+5,buttonsTop,2,buttonsPlayLenght);
			buttonPause1.graphics.endFill();
			buttonPause1.mouseEnabled = false;
			addChild(buttonPause1);

			var buttonPause2:Sprite = new Sprite();
			buttonPause2.graphics.lineStyle(1,0x333333);
			buttonPause2.graphics.beginFill(buttonColor);
			buttonPause2.graphics.drawRect(buttonsLeft+buttonsPlayLenght+9,buttonsTop,2,buttonsPlayLenght);
			buttonPause2.graphics.endFill();
			buttonPause2.mouseEnabled = false;
			addChild(buttonPause2);

			var buttonPause:Sprite = new Sprite();
			buttonPause.graphics.beginFill(0xFFAAAA);
			buttonPause.alpha = 0;
			buttonPause.graphics.drawRect(buttonsLeft+buttonsPlayLenght+3,buttonsTop-1,12,buttonsPlayLenght+3);
			buttonPause.graphics.endFill();
			buttonPause.buttonMode = true;
			buttonPause.addEventListener(MouseEvent.MOUSE_UP, upPause);
			buttonPause.addEventListener(MouseEvent.MOUSE_DOWN, downPause);
			buttonPause.addEventListener(MouseEvent.MOUSE_OVER, overPause);
			buttonPause.addEventListener(MouseEvent.MOUSE_OUT, outPause);
			addChild(buttonPause);
			
			function outPause (event:MouseEvent):void {
				buttonPause1.graphics.beginFill(buttonColor);
				buttonPause1.graphics.drawRect(buttonsLeft+buttonsPlayLenght+5,buttonsTop,2,buttonsPlayLenght);
				buttonPause1.graphics.endFill();
				
				buttonPause2.graphics.beginFill(buttonColor);
				buttonPause2.graphics.drawRect(buttonsLeft+buttonsPlayLenght+9,buttonsTop,2,buttonsPlayLenght);
				buttonPause2.graphics.endFill();
			}
			
			function overPause (event:MouseEvent):void {
				buttonPause1.graphics.beginFill(0xe05555);
				buttonPause1.graphics.drawRect(buttonsLeft+buttonsPlayLenght+5,buttonsTop,2,buttonsPlayLenght);
				buttonPause1.graphics.endFill();
				
				buttonPause2.graphics.beginFill(0xe05555);
				buttonPause2.graphics.drawRect(buttonsLeft+buttonsPlayLenght+9,buttonsTop,2,buttonsPlayLenght);
				buttonPause2.graphics.endFill();
			}

			function downPause (event:MouseEvent):void {
				buttonPause1.graphics.beginFill(0xff0000);
				buttonPause1.graphics.drawRect(buttonsLeft+buttonsPlayLenght+5,buttonsTop,2,buttonsPlayLenght);
				buttonPause1.graphics.endFill();
				
				buttonPause2.graphics.beginFill(0xff0000);
				buttonPause2.graphics.drawRect(buttonsLeft+buttonsPlayLenght+9,buttonsTop,2,buttonsPlayLenght);
				buttonPause2.graphics.endFill();
				clickSound.play(100);
			}

			function upPause (event:MouseEvent):void {
				MovieClip(parent).runAnimation = false;
				overPause(event);
			}
			
		}
		
		function addInfoBox():void {
			var infoFieldFormat:TextFormat = new TextFormat("Arial", 12, 0);
			infoFieldFormat.align = TextFormatAlign.LEFT;
			infoFieldFormat.color = "0x000000";

			var myFormatHeader:TextFormat = new TextFormat("Arial", 12, 0);
			myFormatHeader.align = TextFormatAlign.LEFT;
			myFormatHeader.color = "0x333333";
			myFormatHeader.italic = true;
			
			var matr:Matrix = new Matrix();
			matr.createGradientBox(200, 800, Math.PI / 2, 0, 0);

			var infoField:Sprite = new Sprite();
			infoField.graphics.lineStyle(1,0xAAAAAA);
			//infoField.graphics.beginFill(0xFFEEEE);
			infoField.graphics.beginGradientFill(GradientType.LINEAR, [0xDDDDDD,0xFFFFFF], [1,1], [0,255], matr, SpreadMethod.PAD);
			infoField.graphics.drawRect(800,-2,200,800);
			infoField.graphics.endFill();
			addChild(infoField);

			infoFieldText = new TextField();
			//infoFieldText.embedFonts = true;
			//infoFieldText.border = true;
			infoFieldText.antiAliasType = AntiAliasType.ADVANCED;
			infoFieldText.wordWrap = true;
			infoFieldText.defaultTextFormat = infoFieldFormat;
//			infoFieldText.text = "Each bubble represents a specific area of European Union activity. The area of the bubble reflects the number of EU legislative acts within the policy area.\n\nUse the timeline to navigate in time. Place the cursor on a bubble to see additional information."; // +String(ci); //set name of circle
			infoFieldText.width = 180;
			infoFieldText.height = 400;
			infoFieldText.x = 805;
			infoFieldText.y = 90;
			infoFieldText.mouseEnabled = false;
			addChild(infoFieldText);

			infoFieldHeader = new TextField();
			//infoFieldHeader.embedFonts = true;
			infoFieldHeader.antiAliasType = AntiAliasType.ADVANCED;
			infoFieldHeader.wordWrap = true;
			infoFieldHeader.defaultTextFormat = myFormatHeader;
//			infoFieldHeader.text = "EU legislation";
			infoFieldHeader.width = 195;
			infoFieldHeader.height = 70;
			infoFieldHeader.x = 805;
			infoFieldHeader.y = 40;
			infoFieldHeader.mouseEnabled = false;
			addChild(infoFieldHeader);
			
			infoFieldActText = new TextField();
			//infoFieldText.embedFonts = true;
			//infoFieldText.border = true;
			infoFieldActText.antiAliasType = AntiAliasType.ADVANCED;
			infoFieldActText.wordWrap = true;
			infoFieldActText.defaultTextFormat = infoFieldFormat;
			infoFieldActText.text = "this is more numbers";
			infoFieldActText.width = 180;
			infoFieldActText.height = 200;
			infoFieldActText.x = 805;
			infoFieldActText.y = 290;
			infoFieldActText.mouseEnabled = false;
			addChild(infoFieldActText);

		} //end addInfoBox
						
		function drawRuler():void {
			//draw ruler
			const rulerHeight:int = 151;
			const rulerLeft:int = 8;
			const rulerTop:int = 300;
			const rulerWidth:int = 1;
			const rulerMarkWidth:int = 6;
			const rulerColor:uint = 0x333333;
			
			var rulerFormat:TextFormat = new TextFormat("Arial", 10, 0);
			rulerFormat.align = TextFormatAlign.LEFT;
			rulerFormat.color = String(rulerColor);
			rulerFormat.bold = false;
			
			var ruler:Sprite = new Sprite;
			ruler.graphics.beginFill(rulerColor);
			ruler.graphics.drawRect(rulerLeft,rulerTop,rulerWidth,rulerHeight);
			ruler.graphics.endFill();
			ruler.mouseEnabled = false;
			addChild(ruler);
			
			var rulerMarkTop:Sprite = new Sprite;
			rulerMarkTop.graphics.beginFill(rulerColor);
			rulerMarkTop.graphics.drawRect(rulerLeft,rulerTop,rulerMarkWidth,rulerWidth);
			rulerMarkTop.graphics.endFill();
			rulerMarkTop.mouseEnabled = false;
			addChild(rulerMarkTop);

			rulerMarkTopText = new TextField();
			rulerMarkTopText.defaultTextFormat = rulerFormat;
			rulerMarkTopText.x = rulerLeft+rulerMarkWidth+2;
			rulerMarkTopText.y = rulerTop-8;
			rulerMarkTopText.background = false;
			rulerMarkTopText.text = "3000 acts";
			rulerMarkTopText.mouseEnabled = false;
			addChild(rulerMarkTopText);
			
			var rulerMarkBottom:Sprite = new Sprite;
			rulerMarkBottom.graphics.beginFill(rulerColor);
			rulerMarkBottom.graphics.drawRect(rulerLeft,rulerTop+rulerHeight,rulerMarkWidth,rulerWidth);
			rulerMarkBottom.graphics.endFill();
			addChild(rulerMarkBottom);

			var rulerMarkBottomText:TextField = new TextField();
			rulerMarkBottomText.defaultTextFormat = rulerFormat;
			rulerMarkBottomText.x = rulerLeft+rulerMarkWidth+2;
			rulerMarkBottomText.y = rulerTop+rulerHeight-8;
			rulerMarkBottomText.background = false;
			//rulerMarkTopText.embedFonts = true;
			rulerMarkBottomText.text = "0 acts";
			rulerMarkBottomText.mouseEnabled = false;
			addChild(rulerMarkBottomText);

			
			var rulerMarkMiddle:Sprite = new Sprite;
			rulerMarkMiddle.graphics.beginFill(rulerColor);
			rulerMarkMiddle.graphics.drawRect(rulerLeft,rulerTop+rulerHeight-87,rulerMarkWidth,rulerWidth);
			rulerMarkMiddle.graphics.endFill();
			rulerMarkMiddle.mouseEnabled = false;
			addChild(rulerMarkMiddle);

			rulerMarkMiddleText = new TextField();
			rulerMarkMiddleText.defaultTextFormat = rulerFormat;
			rulerMarkMiddleText.x = rulerLeft+rulerMarkWidth+2;
			rulerMarkMiddleText.y = rulerTop+rulerHeight-87-8;
			rulerMarkMiddleText.background = false;
			rulerMarkMiddleText.text = "1000 acts";
			rulerMarkMiddleText.mouseEnabled = false;
			addChild(rulerMarkMiddleText);

						
			var rulerMark2:Sprite = new Sprite;
			rulerMark2.graphics.beginFill(rulerColor);
			rulerMark2.graphics.drawRect(rulerLeft,rulerTop+rulerHeight-62,rulerMarkWidth,rulerWidth);
			rulerMark2.graphics.endFill();
			rulerMark2.mouseEnabled = false;
			addChild(rulerMark2);
//124px=2000 acts
			rulerMark2Text = new TextField();
			rulerMark2Text.defaultTextFormat = rulerFormat;
			rulerMark2Text.x = rulerLeft+rulerMarkWidth+2;
			rulerMark2Text.y = rulerTop+rulerHeight-62-8;
			rulerMark2Text.background = false;
			rulerMark2Text.text = "500 acts";
			rulerMark2Text.mouseEnabled = false;
			addChild(rulerMark2Text);
			
			var rulerMarkQuarter:Sprite = new Sprite;
			rulerMarkQuarter.graphics.beginFill(rulerColor);
			rulerMarkQuarter.graphics.drawRect(rulerLeft,rulerTop+rulerHeight-28,rulerMarkWidth,rulerWidth);
			rulerMarkQuarter.graphics.endFill();
			rulerMarkQuarter.mouseEnabled = false;
			addChild(rulerMarkQuarter);
			
			rulerMarkQuarterText = new TextField();
			rulerMarkQuarterText.defaultTextFormat = rulerFormat;
			rulerMarkQuarterText.x = rulerLeft+rulerMarkWidth+2;
			rulerMarkQuarterText.y = rulerTop+rulerHeight-28-8;
			rulerMarkQuarterText.background = false;
			rulerMarkQuarterText.text = "100 acts";
			rulerMarkQuarterText.mouseEnabled = false;
			addChild(rulerMarkQuarterText);
		} //end draw ruler
	
		function addYears():void { //add years and timeline
			years = new Array;
			yearButtons = new Array;
			timelinebar = new Sprite();
			var timeline:Sprite = new Sprite();

			yearFormat = new TextFormat("Arial", 10, 0);
			yearFormat.align = TextFormatAlign.LEFT;
			yearFormat.color = "0x333333";
			yearFormat.bold = false;

			yearFormatb = new TextFormat("Arial", 10, 0);
			yearFormatb.align = TextFormatAlign.LEFT;
			yearFormatb.color = "0x000000";
			yearFormatb.bold = true;
		
			timeline.graphics.lineStyle(1,0x333333);
			timeline.graphics.beginFill(0xAAAAAA);
			timeline.graphics.drawRect(8,520,782,4);
			timeline.graphics.endFill();
			addChild(timeline);
			
			timelinebar.graphics.beginFill(0xFF0000);
			timelinebar.graphics.drawRect(0, 520, 1, 4);
			timelinebar.x = 8;
			timelinebar.graphics.endFill();
			timelinebar.alpha = 0.5;
			addChild(timelinebar);
			
			for (var i:int = 0; i <= maxYear; i++) {
				years[i] = new TextField();
				years[i].defaultTextFormat = yearFormat;
				years[i].x = 12.8 * i + 11;
				years[i].y = 523;
				years[i].background = false;
				years[i].embedFonts = true;
				years[i].rotation = 65;
				years[i].text = String(1950 + i);
				years[i].mouseEnabled = false;
				addChild(years[i]);
				
				yearButtons[i] = new Sprite();
				yearButtons[i].graphics.beginFill(0xAAAAAA);
				yearButtons[i].alpha = 0;
				yearButtons[i].graphics.drawRect(0,0,13,50);
				yearButtons[i].graphics.endFill();
				yearButtons[i].x = 12.8 * i + 2;
				yearButtons[i].y = 514;
				yearButtons[i].buttonMode = true;
				yearButtons[i].addEventListener(MouseEvent.MOUSE_UP, clickYear);
				yearButtons[i].addEventListener(MouseEvent.MOUSE_DOWN, downYear);
				yearButtons[i].addEventListener(MouseEvent.MOUSE_OVER, overYear);
				yearButtons[i].addEventListener(MouseEvent.MOUSE_OUT, outYear);
				addChild(yearButtons[i]);
			}

			function clickYear (event:MouseEvent):void {
				yearSound.play(200);
				var y:int = yearButtons.indexOf(event.target);
				MovieClip(parent).changeYear(y);
				years[yearButtons.indexOf(event.target)].textColor = 0x333333;
			} //end click
		
		} //end addYears
		
		function overYear (event:MouseEvent):void { //hover year
			years[yearButtons.indexOf(event.target)].defaultTextFormat = yearFormatb;
			years[yearButtons.indexOf(event.target)].text = 1950 + yearButtons.indexOf(event.target);
		} //end overYear

		function downYear (event:MouseEvent):void { //hover year
			years[yearButtons.indexOf(event.target)].textColor = 0xFF0000;
		} //end downYear
		
		function outYear (event:MouseEvent):void { //hover year
			years[yearButtons.indexOf(event.target)].defaultTextFormat = yearFormat;
			years[yearButtons.indexOf(event.target)].text = 1950 + yearButtons.indexOf(event.target);
		} //end outYear

		} //end scenary function
		
		public function moveTimeline (y:int):void {
			//TweenLite.to(timelinebar, timeunit, { scaleX:12.8 * y + 2, onComplete:nextYear } ); //move timeline
			TweenLite.to(timelinebar, timeunit, { scaleX:12.8 * y + 2, onComplete:nextYear, ease:Linear.easeNone } ); //move timeline
		} //end moveTimeline
	
		public function nextYear():void {
			MovieClip(parent).nextYear();
		}

		public function setInfoBoxText(headerText:String, infoText:String):void {
			infoFieldHeader.text = headerText;
			infoFieldText.text = infoText;
		} //setInfoBoxText

		public function setActInfo(acts:Array, directives:Array, regulations:Array, decisions:Array):void {
			this.acts = acts;
			this.directives = directives;
			this.regulations = regulations;
			this.decisions = decisions;
			updateActInfo();
		}
		
		public function updateActInfo():void {
//			var y:int = 40;// MovieClip(parent).getThisyear();
			var y:int = MovieClip(parent).thisyear;
			infoFieldActText.text = 'Year: ' + String(y + 1950) +'\n\nDirectives: '+thusandsseperator(directives[y])+'\nRegulations: '+thusandsseperator(regulations[y])+'\nDecisions: '+thusandsseperator(decisions[y])+'\nLegal acts: '+thusandsseperator(acts[y]);
		}

		public function thusandsseperator(n:int):String {
			var str:String = String(n);
			if (str.length <= 3) {
			  return str;
			}
			return str.substring(0,str.length-3)+'.'+str.substring(str.length-3,str.length);
		}
		public function resetRuler():void {
			updateRuler(3000, 1000, 500, 100);
		}

		public function resetSceneTitle():void {
			addSceneTitle('EU legislation');
		}
					
		public function addSceneTitle(sceneTitle:String):void {
			sceneTitleText.text = sceneTitle;
		}
	/*	
		public function addReplay():void {
			addChild(myLine);  
			addChild(myLineInner);  
			addChild(replayText);
			addChild(buttonReplay);
		}

		public function removeReplay():void {
			if (contains(myLine)) {
				removeChild(buttonReplay);
				removeChild(myLine);  
				removeChild(myLineInner);  
				removeChild(replayText);
			}
		}
*/
		public function updateRuler(top:int, middle:int, middle2:int, quarter:int):void {
			rulerMarkTopText.text = String(top) + ' acts';
			rulerMarkMiddleText.text = String(middle) + ' acts';
			rulerMark2Text.text = String(middle2) + ' acts';
			rulerMarkQuarterText.text = String(quarter) + ' acts';
		}
	} //end Scenary class
} //end package